Imports System
Imports System.xml
Imports System.Text
'Imports Microsoft.VisualBasic
Imports System.Configuration.ConfigurationManager
Public Class Form1
    'E:\vmlChart\xml\OMDapmYuanShi.apm

    Dim xml As New XmlDocument
    Dim tables As XmlNodeList
    Dim table As XmlNode
    Dim Columns As XmlNodeList
    Dim Column As XmlNode
    Dim br As String = vbCrLf


    Dim nsmgr As XmlNamespaceManager

    Dim tableName As String = ""
    Dim tableComment As String = ""
    Dim IsKey As String = ""
    Dim propertyCode As String = ""

    Dim SQLType As String = ""
    Dim DataType As String = ""
    Dim Comment As String = ""
    Dim CreationDate As DateTime
    Dim ModificationDate As DateTime

    Dim offsetHeight As Integer = 120

    Dim pk As String = "Id"
    Dim pkType As String = "long"

    Dim tblClassProperty As New System.Data.DataTable
    'Dim tblClassProperty As New System.Windows.Forms.DataGridView


    Dim dbFilePath As String = "E:\OMD\design\database\"
    Dim dbFileName As String = "OMD.apm"

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SaveConfig()
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        LoadConfig()
        tblClassProperty.Columns.Add("IsKey", System.Type.GetType("System.String"))
        tblClassProperty.Columns.Add("propertyCode", System.Type.GetType("System.String"))
        tblClassProperty.Columns.Add("SQLType", System.Type.GetType("System.String"))
        tblClassProperty.Columns.Add("VBType", System.Type.GetType("System.String"))
        tblClassProperty.Columns.Add("Comment", System.Type.GetType("System.String"))
        tblClassProperty.Columns.Add("CreationDate", System.Type.GetType("System.DateTime"))
        tblClassProperty.Columns.Add("ModificationDate", System.Type.GetType("System.DateTime"))

        dgw.DataSource = tblClassProperty
        dgw.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells

        If FileIO.FileSystem.FileExists(dbFilePath + dbFileName) Then
            XmlFilePath.Text = dbFilePath + dbFileName
            SetTableList()
        End If

    End Sub

    Private Sub LoadConfig()
        'If Not AppSettings("FilePath") Is Nothing Then
        dbFilePath = AppSettings("FilePath")
        dbFileName = AppSettings("FileName")
        NamespaceStr.Text = AppSettings("Namespace")
        prgName.Text = AppSettings("PrgName")
        'txtKey.Text = AppSettings("SearchKey")
        'End If
    End Sub

    Private Sub SaveConfig()
        Dim doc As XmlDocument = New XmlDocument
        Dim strFileName As String = AppDomain.CurrentDomain.BaseDirectory.ToString + "PowerDesign2Domain.exe.config"
        doc.Load(strFileName)
        Dim nodes As XmlNodeList = doc.GetElementsByTagName("add")
        Dim i As Integer = 0

        Dim tempArray As Array
        tempArray = XmlFilePath.Text.Split("\")
        dbFileName = tempArray(tempArray.Length - 1)
        dbFilePath = XmlFilePath.Text.Substring(0, XmlFilePath.Text.Length - dbFileName.Length)
        Dim add As XmlAttribute
        While i < nodes.Count
            Dim adds As XmlAttribute = nodes(i).Attributes("key")
            If adds Is Nothing Then
                Exit While
            End If
            Select Case adds.Value
                Case "FilePath"
                    add = nodes(i).Attributes("value")
                    add.Value = dbFilePath
                Case "FileName"
                    add = nodes(i).Attributes("value")
                    add.Value = dbFileName
                Case "Namespace"
                    add = nodes(i).Attributes("value")
                    add.Value = NamespaceStr.Text
                Case "PrgName"
                    add = nodes(i).Attributes("value")
                    add.Value = prgName.Text
                Case "SearchKey"
                    add = nodes(i).Attributes("value")
                    add.Value = txtKey.Text
                Case Else

            End Select

            System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)

        End While
        doc.Save(strFileName)
    End Sub

    'Private Sub XmlFilePath_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles XmlFilePath.GotFocus
    '    LoadFile()
    'End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        tableList.Height = Me.Height - offsetHeight - 25
        'dgw.Height = Me.Height - offsetHeight
        'classText.Height = Me.Height - offsetHeight

        'dgw.Width = Me.Width * 0.5

        'classText.Width = Me.Width - dgw.Width - tableList.Width - 30
        'classText.Location = New Point(dgw.Width + tableList.Width + 20, classText.Location.Y)
        Tabs.Height = Me.Height - offsetHeight
        Tabs.Width = Me.Width - tableList.Width - 25
    End Sub

    Private Sub TabControl1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Tabs.Resize
        dgw.Height = Tabs.Height - 35
        dgw.Width = Tabs.Width - 15
        classText.Size = dgw.Size
        classText.Height -= 15
        WebUI.Size = dgw.Size
        WebUI.Height -= 15
        WebUIVB.Size = dgw.Size
        WebUIVB.Height -= 15

        IBatisMap.Size = dgw.Size
        InterfacesCode.Size = dgw.Size
        MapperDaoCode.Size = dgw.Size
        'tableList.Height -= 10
        'cbxCheckAll.Height = Me.Size.Height - 5
    End Sub

    Private Sub btnLoadXml_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadXml.Click
        LoadFile()
        If XmlFilePath.Text <> "" Then
            SetTableList()
        End If
    End Sub

    ''' <summary>
    ''' ѡ PD ļ 
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub LoadFile()
        Dim OFD As New OpenFileDialog()
        OFD.FileName = dbFileName

        OFD.InitialDirectory = dbFilePath
        OFD.Filter = "PowerDesgin files (*.apm;*.pdb;*.pdm)|*.apm;*.pdb;*.pdm"

        OFD.FilterIndex = 2
        OFD.RestoreDirectory = True
        OFD.Title = "ѡ PowerDesgin ļ"
        If OFD.ShowDialog() = Windows.Forms.DialogResult.OK Then
            XmlFilePath.Text = OFD.FileName

            'Me.dbFileName = OFD.FileName
            'SaveConfig()
        End If

        'OFD = Nothing
    End Sub

    Private Sub LoadXml()
        xml.Load(XmlFilePath.Text)
        nsmgr = New XmlNamespaceManager(xml.NameTable)
        nsmgr.AddNamespace("a", "attribute")
        nsmgr.AddNamespace("c", "collection")
        nsmgr.AddNamespace("o", "object")
        tables = xml.SelectSingleNode("//o:RootObject/c:Children/o:Model/c:Tables", nsmgr).ChildNodes
    End Sub

    Private Sub SetTableList()
        LoadXml()
        tableList.Items.Clear()
        'clbTableList.Items.Clear()

        If txtKey.Text <> "" Then
            For Each table In tables
                tableName = table.SelectSingleNode("a:Code", nsmgr).InnerText
                If tableName.ToLower.StartsWith(txtKey.Text.ToLower) Then
                    tableList.Items.Add(tableName)
                    'clbTableList.Items.Add(tableName)
                End If
            Next

        Else
            For Each table In tables
                tableName = table.SelectSingleNode("a:Code", nsmgr).InnerText
                tableList.Items.Add(tableName)
                'clbTableList.Items.Add(tableName)
            Next
        End If


        'tableList.SetSelected(i, True)

        If tableList.Items.Count = 1 Then
            tableList.SetSelected(0, True)
        End If
        'If tableList.Items.Count = 0 Then
        '    'MsgBox("ļûκα!", MsgBoxStyle.OkOnly)
        'Else
        '    tableList.SelectedIndex = 0
        'End If
    End Sub

    Private Sub GetTableList()
        tblClassProperty.Clear()
        LoadXml()
        Dim tempTable As XmlNode

        Dim tableFind As Boolean = False
        For Each tempTable In tables
            tableName = tempTable.SelectSingleNode("a:Code", nsmgr).InnerText
            If tableName = tableList.Text Then
                table = tempTable
                tableFind = True
                Exit For
            End If
        Next
        If tableFind = False Then
            Exit Sub
        End If

        'tableName = table.SelectSingleNode("a:Code", nsmgr).InnerText
        classNameStr.Text = SetClassName(tableName)
        Try
            ClassComment.Text = table.SelectSingleNode("a:Comment", nsmgr).InnerText
        Catch ex As Exception
            ClassComment.Text = ""
        End Try
        Columns = table.SelectNodes("c:Columns/o:Column", nsmgr)


        'ֶ

        Dim timeStart As New Date(1970, 1, 1)

        For Each Column In Columns
            Try
                IsKey = Column.SelectSingleNode("a:Identity", nsmgr).InnerText
            Catch ex As Exception
                IsKey = ""
            End Try

            propertyCode = Column.SelectSingleNode("a:Code", nsmgr).InnerText
            Try

                SQLType = Column.SelectSingleNode("a:DataType", nsmgr).InnerText
                DataType = GetDataType(SQLType)
            Catch ex As Exception
                SQLType = ""
                DataType = "String"
            End Try
            Try
                Comment = Column.SelectSingleNode("a:Comment", nsmgr).InnerText.Trim.Replace(Chr(13) & Chr(10), "|")
            Catch ex As Exception
                Comment = ""
            End Try

            Try
                'Dim CreationDate As DateTime
                'Dim ModificationDate As DateTime

                CreationDate = timeStart + New TimeSpan(8, 0, CLng(Column.SelectSingleNode("a:CreationDate", nsmgr).InnerText))
                ModificationDate = timeStart + New TimeSpan(8, 0, CLng(Column.SelectSingleNode("a:ModificationDate", nsmgr).InnerText))
            Catch ex As Exception

            End Try
            AddRow(IsKey, propertyCode, SQLType, DataType, Comment, CreationDate, ModificationDate)
        Next

    End Sub

    ''' <summary>
    ''' ¶ѡıӿڴ
    ''' </summary>
    ''' <remarks></remarks>
    ''' 
    Private Sub GetInterfaces()
        GetPk()
        Dim cn As String = classNameStr.Text
        Dim cc As String = ClassComment.Text.Replace(br, " ")
        Dim code As New StringBuilder
        code.Append("Imports " + NamespaceStr.Text + br)
        code.Append("Namespace Persistence.Interfaces" + br)
        code.Append(Summary(cc + "ӿ"))
        code.Append(Remarks("Code By " + System.Environment.MachineName + " @" + Now.Date.ToString.Replace(" 0:00:00", "")))
        code.Append("    Public Interface I" + cn + br)

        code.Append(Summary("" + cc))
        code.Append(Param("obj" + cn, cc + ""))
        code.Append(Returns("" + cc + "" + pk))
        code.Append("        Function Insert(ByVal obj" + cn + " As " + cn + ") As Long" + br + br)

        code.Append(Summary("" + cc))
        code.Append(Param("obj" + cn, cc + ""))
        code.Append("        Sub Update(ByVal obj" + cn + " As " + cn + ")" + br + br)

        code.Append(Summary("ɾ" + cc))
        code.Append(Param(pk, cc + ""))
        code.Append("        Sub Delete(ByVal " + pk + " As Long)" + br + br)

        code.Append(Summary("ɾ" + cc))
        code.Append(Param(pk, cc + ""))
        code.Append("        Sub Delete(ByVal " + pk + "() As Long)" + br + br)

        code.Append(Summary("ȡȫ" + cc))
        code.Append(Returns(cc + ""))
        code.Append("        Function Get" + cn + "s() As ArrayList" + br + br)

        code.Append(Summary("ȡ" + cc + ""))
        code.Append(Param(pk, cc + ""))
        code.Append(Returns(cc + ""))
        code.Append("        Function Get" + cn + "(ByVal " + pk + " As Long) As " + cn + br + br)

        code.Append(Summary("ָѯ" + cc))
        code.Append(Param("Condition", "ָ(SQL)"))
        code.Append(Returns(cc + ""))
        code.Append("        Function Search(ByVal Condition As String) As ArrayList" + br + br)

        code.Append("    End Interface" + br)
        code.Append("End Namespace")
        InterfacesCode.Text = code.ToString
    End Sub

#Region "ע"

    Private Function GetSpace(ByVal space As UShort) As String
        Dim s As String = ""
        Select Case space
            Case 0
            Case 2
                s = "  "
            Case 4
                s = "    "
            Case 8
                s = "        "
        End Select
        s += "''' "
        Return s
    End Function

    Function Summary(ByVal Comment As String, Optional ByVal space As UShort = 8) As String
        Dim s As String = GetSpace(space)
        Return s + "<summary>" + br + s + Comment + br + s + "</summary>" + br
    End Function

    Function Param(ByVal propertyCode As String, ByVal Comment As String, Optional ByVal space As UShort = 8) As String
        Dim s As String = GetSpace(space)
        Return s + "<param name=""" + propertyCode + """>" + Comment + "</param>" + br
    End Function

    Function Returns(ByVal Comment As String, Optional ByVal space As UShort = 8) As String
        Dim s As String = GetSpace(space)
        Return s + "<returns>" + Comment + "</returns>" + br
    End Function

    Function Remarks(ByVal Comment As String, Optional ByVal space As UShort = 8) As String
        Dim s As String = GetSpace(space)
        Return s + "<remarks>" + br + s + Comment + br + s + "</remarks>" + br
    End Function

#End Region

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="propertyCode"></param>
    ''' <param name="DataType"></param>
    ''' <param name="Comment"></param>
    ''' <remarks></remarks>
    Private Sub AddRow( _
        ByVal IsKey As String, _
        ByVal propertyCode As String, _
        ByVal SQLType As String, _
        ByVal DataType As String, _
        ByVal Comment As String, _
        ByVal CreationDate As DateTime, _
        ByVal ModificationDate As DateTime _
        )
        Dim objRow As System.Data.DataRow
        objRow = tblClassProperty.NewRow()
        objRow("IsKey") = IsKey
        objRow("propertyCode") = FirstUpper(propertyCode)
        objRow("SQLType") = SQLType
        objRow("VBType") = DataType
        objRow("Comment") = Comment
        objRow("CreationDate") = CreationDate
        objRow("ModificationDate") = ModificationDate
        tblClassProperty.Rows.Add(objRow)
    End Sub

    ''' <summary>
    ''' ݿתΪVB.Net
    ''' </summary>
    ''' <param name="str"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetDataType(ByVal str As String) As String
        str = str.Trim().ToLower()

        If (("my" & str).IndexOf("char") > 0) Then
            str = "String"
        End If

        Select Case str
            Case "smallint"
                Return "Integer"
            Case "int"
                Return "Long"
            Case "datetime", "smalldatetime"
                Return "DateTime"
            Case "float"
                Return "Double"
            Case "money"
                Return "Decimal"
            Case "bit"
                Return "Boolean"
            Case "ntext", "text"
                Return "String"
            Case Else
                Return str
        End Select

    End Function

    Private Function SetClassName(ByVal str As String) As String

        'Dim temp As String = Left(str, 3)
        Dim temp As String = Mid(str, 1, 3)


        If temp = "tbl" Or temp = "dev" Or temp = "cmd" Or temp = "omd" Then
            Return FirstUpper(str.Substring(3))
        Else
            Return str
        End If

    End Function

    ''' <summary>
    ''' ĸд
    ''' </summary>
    ''' <param name="str"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FirstUpper(ByVal str As String) As String
        'Return Left(str, 1).ToUpper + str.Substring(1)
        Return Mid(str, 1, 1).ToUpper + str.Substring(1)
    End Function

    Private Function TableToCode() As String

        If dgw.RowCount < 2 Then
            Return ""
            'Exit Function
        End If
        Dim code As New System.Text.StringBuilder
        Dim privates, properties, propertyCode, VBType, newsCode, newsCodeSummary, newsCodeBody, Comment As String
        privates = ""
        properties = ""
        newsCode = ""
        newsCodeSummary = ""
        newsCodeBody = ""

        If cbxImports.Checked Then
            code.Append("Imports OMD.MyGlobal.Base.Domain" + br)
            code.Append("Imports OMD.StoreManager.Domain" + br)
            code.Append("Imports OMD.MyGlobal.Constant" + br + br)
        End If

        code.Append("Namespace " + NamespaceStr.Text + br + br)
        code.Append(Summary(ClassComment.Text, 4))
        code.Append(Remarks("Code By " + System.Environment.MachineName, 4))

        code.Append("    Public Class " + classNameStr.Text + br)

        If InheritsClass.Text <> "" Then
            code.Append("        Inherits " + InheritsClass.Text + br + br)
        End If

        newsCodeSummary += Summary(ClassComment.Text + "캯")

        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            propertyCode = FirstUpper(objRow("propertyCode"))
            VBType = objRow("VBType")
            Comment = "" + objRow("Comment")
            '˽б
            privates += "        Private _" + propertyCode + " As " + VBType + br




            '캯
            If Comment.Length > 0 Then
                newsCodeSummary += Param(propertyCode, Comment.Replace("|", " "))
            End If
            newsCode += "           ByVal " + propertyCode + " As " + VBType + ", _" + br

            newsCodeBody += "            _" + propertyCode + " = " + propertyCode + br


            properties += GetProperty(objRow) + br

        Next
        If ck1.Checked Then

            newsCode = Mid(newsCode, 1, newsCode.Length - 5) + " _"
            newsCode = "        Sub New( _" + br + newsCode + br
            newsCode += "            )" + br
            newsCode += newsCodeBody
            newsCode += "        End Sub" + br + br

        End If

        If cbxAddSoreObj.Checked Then
            privates += br + "        Private _OMDStore As New OMDStore" + br
        End If

        'ע
        privates = br + "#Region ""˽б""" + br + privates + br + "#End Region" + br

        code.Append(privates + br)
        code.Append("        Sub New()" + br)

        If InheritsClass.Text <> "" Then
            GetPk()
            code.Append("           MyBase.FlowFileType = SystemConstant.FLOWFILE_TYPE    '޸" + br)
            code.Append("           MyBase.DBTableName = """ + tableList.Text + """" + br)
            code.Append("           MyBase.DBPKFieldName = """ + pk + """" + br)
        End If

        code.Append("        End Sub" + br + br)
        If ck1.Checked Then
            code.Append(newsCodeSummary)
            code.Append(newsCode + br)
        End If

        If cbxAddSoreObj.Checked Then
            code.Append(Summary(""))
            code.Append("        Public Property OMDStore() As OMDStore" + br)
            code.Append("            Get" + br)
            code.Append("                    Return _OMDStore" + br)
            code.Append("                End Get" + br)
            code.Append("            Set(ByVal value As OMDStore)" + br)
            code.Append("                _OMDStore = value" + br)
            code.Append("                MyBase._StoreId = _OMDStore.StoreID" + br)
            code.Append("            End Set" + br)
            code.Append("        End Property" + br + br)
        End If

        properties = br + "#Region """"" + br + properties + "#End Region" + br

        code.Append(properties)

        code.Append("   End Class " + br + br)

        code.Append("End Namespace" + br)
        'dgw.DataSource = tblClassProperty

        classText.Text = code.ToString
        Return code.ToString

    End Function

    ''' <summary>
    ''' WebUI
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub GetWebUICode()
        Dim code As String = "<table border=""1"">" + br

        Dim temp As String = ""
        Dim TextBox As String = ""
        Dim tagName As String = "asp"

        For Each objRow As System.Data.DataRow In tblClassProperty.Rows

            If cbxDataCheck.Checked Then
                Dim VBType As String = objRow("VBType")
                Select Case VBType
                    Case "Integer", "Long", "DateTime", "Double", "Decimal"
                        tagName = "msi"
                    Case Else
                End Select
            Else
                tagName = "asp"
            End If

            code += "<tr>"
            code += "<td>" + objRow("Comment") + "</td>"

            code += "<td><" + tagName + ":TextBox ID=""" + objRow("propertyCode") + """ runat=""server"" "
            code += GetCss(objRow)
            code += "></" + tagName + ":TextBox></td>"

            code += "<td><asp:Literal ID=""Literal_" + objRow("propertyCode") + """ runat=""server"" "
            code += "></asp:Literal></td>"

            code += "</tr>" + br

            temp += "<asp:Literal ID=""" + objRow("propertyCode") + """ runat=""server""></asp:Literal>"
            temp += "                '" + objRow("Comment") + br

            If HTMLCode.Checked Then
                TextBox += "<" + tagName + ":TextBox ID=""" + objRow("propertyCode") + """  runat=""server""" + GetCss(objRow) + "></" + tagName + ":TextBox>"
                TextBox += "                '" + objRow("Comment") + br
            End If
        Next
        code += "</table>" + br + br + temp + br + br + TextBox
        WebUI.Text = code

    End Sub

    ''' <summary>
    ''' ʽ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetCss(ByVal objRow As System.Data.DataRow) As String
        Dim VBType As String = objRow("VBType")
        Dim SQLType As String = objRow("SQLType")

        If cbxDataCheck.Checked Then
            Select Case VBType
                Case "Integer", "Long"
                    Return " CssClass=""SmallSize DataCheck"" DataType=""Int"""
                Case "DateTime"
                    Return " CssClass=""SetDay"""
                Case "Double", "Decimal"
                    Return " CssClass=""SmallSize DataCheck"""
                Case Else
                    Return GetMaxLength(SQLType)
            End Select
        Else
            Return ""
        End If
    End Function

    Private Function GetMaxLength(ByVal SQLType As String) As String
        Dim temp As String = ""
        If SQLType.EndsWith(")") Then
            Dim MaxLength As Integer = CInt(SQLType.Substring(SQLType.IndexOf("(") + 1, SQLType.Length - SQLType.IndexOf("(") - 2))
            temp = " MaxLength=""" + MaxLength.ToString + """ "

            If MaxLength > 100 Then
                temp += " TextMode=""MultiLine"" "
            End If
        End If
        Return temp
    End Function

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="objRow"></param>
    ''' <returns></returns>
    ''' <remarks>
    ''' ͳһȡValue
    ''' </remarks>
    Private Function ChangeType(ByVal objRow As System.Data.DataRow) As String

        Dim temp As String = objRow("propertyCode") + ".Text"
        If ckxChangeType.Checked Then


            Select Case objRow("VBType")
                Case "Integer", "Long", "DateTime", "Double", "Decimal"
                    'temp = "Utility.EmptyFormat(" + temp + ")"

                    temp = temp.Replace(".Text", ".Value")
                    'Case "Integer"
                    '    temp = "CInt(" + temp + ")"
                    'Case "Long"
                    '    temp = "CLng(" + temp + ")"
                    'Case "DateTime"
                    '    temp = "CDate(" + temp + ")"
                    'Case "Double"
                    '    temp = "CDbl(" + temp + ")"
                    'Case "Decimal"
                    '    temp = "CDec(" + temp + ")"
                Case Else

            End Select
        End If

        Return temp
    End Function

    'Private Function SetChangeType(ByVal objRow As System.Data.DataRow) As String
    '    Dim temp As String = objRow("propertyCode") + ".Text"
    '    If ckxChangeType.Checked Then
    '        Select Case objRow("VBType")
    '            Case "Integer", "Long", "DateTime", "Double", "Decimal"
    '                temp = temp.Replace(".Text", ".Value")
    '            Case Else

    '        End Select
    '    End If
    'End Function

    Private Sub GetWebUIVBCode()
        Dim codeGet As String = "    Get" + br
        codeGet += "       Dim obj As New " + classNameStr.Text + br

        Dim codeSet As String = "    Set(ByVal value As " + classNameStr.Text + ")" + br
        Dim temp As String = "Private Property Obj" + classNameStr.Text + "() As " + classNameStr.Text + br
        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            'temp = "Text"
            'If objRow("SQLType") = "bit" Then
            '    temp = "value"
            'End If

            codeGet += "       obj." + FirstUpper(objRow("propertyCode")) + " = " + ChangeType(objRow)
            'codeSet += "       " + objRow("propertyCode") + ".Text = " + DateTimeFormat(objRow)
            codeSet += "       " + ChangeType(objRow) + " = " + "value." + objRow("propertyCode")

            If cbxNeedComment.Checked And objRow("Comment") <> "" Then
                codeGet += "    '" + objRow("Comment")
                codeSet += "    '" + objRow("Comment")
            End If
            codeSet += br
            codeGet += br
        Next
        codeGet += "       Return obj" + br
        codeGet += "    End Get" + br
        codeSet += "    End Set" + br
        temp += codeGet + codeSet
        temp += "End Property" + br

        WebUIVB.Text = temp
    End Sub

    Private Function DateTimeFormat(ByVal objRow As System.Data.DataRow) As String
        Dim propertyCode As String = objRow("propertyCode")
        If ckxChangeType.Checked Then
            Select Case objRow("VBType")
                Case "Integer", "Long", "DateTime", "Double", "Decimal"
                    Return "Utility.EmptyFormat(value." + propertyCode + ")"
                Case "DateTime"
                    Return "Utility.DateTimeFormat(value." + propertyCode + ")"
                Case Else
                    Return "value." + propertyCode + ""
            End Select
        Else
            Return "value." + propertyCode + ""
        End If
    End Function

    ''' <summary>
    ''' õһ
    ''' </summary>
    ''' <param name="objRow"></param>
    Private Function GetProperty(ByVal objRow As System.Data.DataRow) As String
        Dim code, propertyCode, temp() As String
        code = ""
        propertyCode = FirstUpper(objRow("propertyCode"))
        'Return objRow("Comment")
        If "" + objRow("Comment") <> "" Then
            code = "        ''' <summary>" + br
            If ck1.Checked Then
                temp = objRow("Comment").Split("|")
                For Each s As String In temp
                    code += "        ''' " + s.Trim() + br
                Next
            Else
                code += "        ''' " + objRow("Comment").Replace("|", "<br />") + br
            End If
            code += "        ''' </summary>" + br
        End If


        code += "        Public Property " + propertyCode + "() As " + objRow("VBType") + br
        code += "            Get " + br
        code += "                Return _" + propertyCode + br
        code += "            End Get " + br
        code += "            Set(ByVal value As " + objRow("VBType") + ")" + br
        code += "                _" + propertyCode + " = value" + br
        code += "            End Set " + br
        code += "        End Property" + br

        Return code

    End Function

    Private Sub GetPk()


        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            If "" + objRow("IsKey") = "1" Then
                pk = objRow("propertyCode")
                pkType = objRow("VBType").ToString.ToLower
                Exit For
            End If
        Next

        If pk.ToLower = "id" Then
            pk = "ID"
        End If
    End Sub

    Private Sub GetIBatisMap()
        GetPk()

        Dim code As New StringBuilder
        Dim temp As String = ""
        code.Append("<?xml version=""1.0"" encoding=""UTF-8"" ?>" + br)
        code.Append("<sqlMap namespace=""" + classNameStr.Text + """ xmlns=""http://ibatis.apache.org/mapping"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"">" + br)
        code.Append("   <alias>" + br)
        code.Append("       <typeAlias alias=""" + classNameStr.Text + """ type=""OMD." + prgName.Text + "." + NamespaceStr.Text + "." + classNameStr.Text + "," + prgName.Text + """/>" + br)
        code.Append("   </alias>" + br)
        code.Append("   <resultMaps>" + br)

        code.Append("       <resultMap id=""" + classNameStr.Text + "Result"" class=""" + classNameStr.Text + """>" + br)
        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            code.Append("       <result property=""" + objRow("propertyCode") + """ column=""" + objRow("propertyCode") + """ /> " + br)
        Next
        code.Append("       </resultMap>" + br)
        code.Append("   </resultMaps>" + br)

        code.Append("   <statements>" + br)


        code.Append("      <select id=""Get" + classNameStr.Text + "s""  resultMap=""" + classNameStr.Text + "Result"">" + br)
        code.Append("           Select ")

        If Not cbxSelectAll.Checked Then
            temp = ""
            For Each objRow As System.Data.DataRow In tblClassProperty.Rows
                temp += "              ," + objRow("propertyCode") + br
            Next
            'temp = temp.Trim()
            'temp = "              " + temp.Substring(1) + br)
            code.Append(br + "              " + rimFirst(temp))
        Else
            code.Append("*")
        End If
        code.Append(br)

        code.Append("               From " + tableList.Text + br)
        code.Append("       </select>" + br)
        code.Append("      <select id=""Get" + classNameStr.Text + "ByID"" extends=""Get" + classNameStr.Text + "s"" parameterClass=""" + pkType + """ resultMap=""" + classNameStr.Text + "Result"">" + br)
        code.Append("           WHERE " + pk + " = #value#" + br)
        code.Append("       </select>" + br)




        code.Append("      <insert id=""Insert" + classNameStr.Text + """>" + br)
        code.Append("          Insert Into " + tableList.Text + " (" + br)

        temp = ""

        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            temp += "              ," + objRow("propertyCode") + br
        Next

        code.Append("              " + rimFirst(temp) + br)
        code.Append("	    )Values(" + br)

        temp = ""
        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            'temp += "              ,#" + objRow("propertyCode") + "#" + br)
            temp += dynamicDateTimeInsert(objRow)
        Next
        code.Append("              " + rimFirst(temp))
        code.Append(br + "	    )" + br)
        code.Append("           SELECT @@identity" + br)
        code.Append("       </insert>" + br)


        code.Append("       <update id=""Update" + classNameStr.Text + """>" + br)
        code.Append("           Update " + tableList.Text + " Set " + br)

        temp = ""
        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            'temp += "              ," + objRow("propertyCode") + " = #" + objRow("propertyCode") + "#," + br)
            If objRow("IsKey") <> "1" Then
                temp += dynamicDateTimeUpdate(objRow)
            End If
        Next
        code.Append("              " + rimFirst(temp))

        code.Append(br + "           WHERE " + pk + " = #" + pk + "#" + br)
        code.Append("       </update>" + br)

        'Begin
        code.Append("       <update id=""Update" + classNameStr.Text + "s""  parameterClass=""ArrayList"">" + br)
        code.Append("           <iterate close="""" conjunction="""" open="""">" + br)
        code.Append("               Update " + tableList.Text + " Set " + br)

        temp = ""
        For Each objRow As System.Data.DataRow In tblClassProperty.Rows
            If objRow("IsKey") <> "1" Then
                temp += "               ," + objRow("propertyCode") + " = " + "#[]." + objRow("propertyCode") + "#" + br
            End If
        Next
        code.Append("               " + rimFirst(temp))
        code.Append(br + "               WHERE " + pk + " = #[]." + pk + "#" + br)
        code.Append("           </iterate>" + br)
        code.Append("       </update>" + br)

        'End

        code.Append("       <delete id=""Delete" + classNameStr.Text + """ parameterClass=""" + pkType + """>" + br)
        code.Append("           Delete From " + tableList.Text + " WHERE " + pk + " = #value# " + br)
        code.Append("       </delete>" + br)
        code.Append("   </statements>" + br)
        code.Append("</sqlMap>")

        IBatisMap.Text = code.ToString
    End Sub

    ''' <summary>
    ''' ж
    ''' </summary>
    ''' <param name="objRow"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function dynamicDateTimeUpdate(ByVal objRow As System.Data.DataRow) As String
        Dim temp As String = ""
        Dim propertyCode As String = objRow("propertyCode")
        If objRow("VBType") = "DateTime" Then
            temp += "           <isNotEqual compareValue=""0001-1-1 0:00:00"" property=""" + propertyCode + """>" + br
            temp += "               ," + propertyCode + "=#" + propertyCode + "#" + br
            temp += "           </isNotEqual>" + br
            temp += "           <isEqual compareValue=""0001-1-1 0:00:00"" property=""" + propertyCode + """>" + br
            temp += "               ," + propertyCode + "=Null" + br
            temp += "           </isEqual>" + br
            Return temp
        Else
            Return "              ," + propertyCode + " = #" + propertyCode + "#" + br
        End If

    End Function

    Private Function dynamicDateTimeInsert(ByVal objRow As System.Data.DataRow) As String
        Dim temp As String = ""
        Dim propertyCode As String = objRow("propertyCode")
        If objRow("VBType") = "DateTime" Then
            temp += "           <isNotEqual compareValue=""0001-1-1 0:00:00"" property=""" + propertyCode + """>" + br
            temp += "               ,#" + propertyCode + "#" + br
            temp += "           </isNotEqual>" + br
            temp += "           <isEqual compareValue=""0001-1-1 0:00:00"" property=""" + propertyCode + """>" + br
            temp += "               ,null" + br
            temp += "           </isEqual>" + br
            Return temp
        Else
            Return "              ,#" + propertyCode + "#" + br
        End If

    End Function

    ''' <summary>
    ''' ȥһǿ ","
    ''' </summary>
    ''' <param name="value"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function rimFirst(ByVal value As String) As String
        value = value.Trim()
        If value.Substring(0, 1) = "," Then
            Return " " + value.Substring(1)
        Else
            Return value
        End If
    End Function

    Private Sub btnMakeClass_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMakeClass.Click
        TableToCode()
        GetWebUICode()
        GetWebUIVBCode()
        GetIBatisMap()
        GetInterfaces()
    End Sub

    ''' <summary>
    ''' ɵļ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSaveFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveFile.Click

        Dim saveFile As New SaveFileDialog()
        saveFile.AddExtension = True
        saveFile.DefaultExt = ".vb"
        saveFile.InitialDirectory = "E:\OMD\sourceCode\"
        saveFile.OverwritePrompt = True
        saveFile.FileName = classNameStr.Text + ".vb"
        saveFile.Filter = "VB files (*.vb)|*.vb"
        If saveFile.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim obj As New System.IO.StreamWriter(saveFile.FileName, False, System.Text.Encoding.GetEncoding("GB2312"))
            obj.Write(classText.Text)
            obj.Close()
        End If


    End Sub

    '#Region "мп ťǷ"
    '    Private Sub dgw_RowsAdded(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowsAddedEventArgs) Handles dgw.RowsAdded
    '        If dgw.RowCount > 1 Then
    '            btnMakeClass.Enabled = True
    '        End If
    '    End Sub

    '    Private Sub dgw_RowsRemoved(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowsRemovedEventArgs) Handles dgw.RowsRemoved
    '        If dgw.RowCount < 2 Then
    '            btnMakeClass.Enabled = False
    '        End If
    '    End Sub
    '#End Region

    Private Sub tableList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tableList.SelectedIndexChanged
        GetTableList()
        'MsgBox(tableList.SelectedItem)
        changeSaveAllFileStatus()

        If tblClassProperty.Columns.Count > 0 Then
            btnMakeClass.Enabled = True
            TableToCode()
            GetWebUICode()
            GetWebUIVBCode()
            GetIBatisMap()
            GetInterfaces()
        End If
    End Sub

    Private Sub changeSaveAllFileStatus()
        If tableList.CheckedItems.Count > 0 And (Tabs.SelectedIndex = 1 Or Tabs.SelectedIndex = 4) Then
            btnSaveAllFile.Enabled = True
        Else
            btnSaveAllFile.Enabled = False
        End If
    End Sub

    Private Sub ckxChangeType_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckxChangeType.CheckedChanged, cbxNeedComment.CheckedChanged
        GetWebUIVBCode()
    End Sub

    Private Sub cbxDataCheck_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxDataCheck.CheckedChanged, HTMLCode.CheckedChanged
        GetWebUICode()
    End Sub

    Private Sub ck1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ck1.CheckedChanged, cbxAddSoreObj.CheckedChanged, cbxImports.CheckedChanged
        TableToCode()
    End Sub

    Private Sub txtKey_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtKey.TextChanged
        SetTableList()
    End Sub

    Private Sub open2File_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles open2File.Click
        FrmReplace2File.Visible = True
    End Sub

    Private Sub btnSaveAllFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveAllFile.Click

        'If tableList.CheckedItems.Count = 0 Then
        '    MsgBox("ѡһ", MsgBoxStyle.OkOnly)
        '    tableList.SetSelected(1, True)
        '    Exit Sub
        'End If

        Dim FBD As New FolderBrowserDialog()
        Dim savePath As String = ""
        Dim i As Integer
        Dim ext As String = ".vb"
        Dim code As String = ""
        FBD.Description = "ѡļĿ¼"
        FBD.SelectedPath = "E:\OMD\sourceCode\"
        If FBD.ShowDialog() = Windows.Forms.DialogResult.OK Then
            savePath = FBD.SelectedPath + "\"

            If Tabs.SelectedIndex = 4 Then
                ext = ".xml"
            End If
            For Each i In tableList.CheckedIndices
                tableList.SetSelected(i, True)
                If Tabs.SelectedIndex = 4 Then
                    code = IBatisMap.Text
                Else
                    code = classText.Text
                End If
                saveFile(savePath + classNameStr.Text + ext, False, code)
            Next
        End If
    End Sub

    Public Sub saveFile(ByVal path As String, ByVal WriteOver As Boolean, ByVal code As String)
        Dim obj As New System.IO.StreamWriter(path, WriteOver, System.Text.Encoding.GetEncoding("GB2312"))
        obj.Write(code)
        obj.Close()
    End Sub

    Private Sub Tabs_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Tabs.SelectedIndexChanged
        changeSaveAllFileStatus()
    End Sub

    Private Sub cbxCheckAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxCheckAll.CheckedChanged
        For i As Integer = 0 To tableList.Items.Count - 1
            tableList.SetItemChecked(i, cbxCheckAll.Checked)
        Next
    End Sub

    Private Sub cbxSelectAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxSelectAll.CheckedChanged
        GetIBatisMap()
    End Sub

End Class
